#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Mon Sep 30 11:48:05 2019

@author: zandieh
"""
import numpy as np
from numpy import linalg as LA
from scipy import linalg as sciLA

def RecNS(s, lambda_, m, Data):
    
    n = Data.shape[0]
    
    if m >= n:
        S = np.arange(n)
        W = np.ones(n)
        return S, W
    
    
    D = Data[np.random.choice(n, int(n/2), replace=False),:]
    S1, W1 = RecNS(s, lambda_, m, D)
    X = D[S1,:]
    
    KSS = np.zeros((X.shape[0],X.shape[0]))
    for i in range(X.shape[0]):
        KSS[i,:] = np.exp(-(LA.norm(X - X[i,:], 2, axis=1)**2)/s)
    KSS = (KSS*W1).T*W1
    
    KS = np.zeros((n,X.shape[0]))
    for i in range(X.shape[0]):
        KS[:,i] = np.exp(-(LA.norm(Data - X[i,:], 2, axis=1)**2)/s)
    KS = KS*W1
    
    M = LA.solve(KSS+lambda_*np.identity(KSS.shape[0]), KS.T)
    L = np.ones(n)
    for i in range(n):
        L[i] = 1 - np.inner(KS[i,:], M[:,i])
    p = L/np.sum(L)
    S = np.random.choice(n, m, replace=False, p=p)
    W = 1/np.sqrt(m*p[S])
    
    return S, W


def NF(s, lambda_, m, Xtrain, Xtest):
    
    n = Xtrain.shape[0]
        
    S = RecNS(s, lambda_, m, Xtrain)[0]
    D = Xtrain[S,:]
    
    Feat_C = np.zeros((m,m))
    for i in range(m):
        Feat_C[i,:] = np.exp(-(LA.norm(D - D[i,:], 2, axis=1)**2)/s)
    
    
    Feat_trn_A = np.zeros((m,n))
    for i in range(m):
        Feat_trn_A[i,:] = np.exp(-(LA.norm(Xtrain - D[i,:], 2, axis=1)**2)/s)
    
    Feat_tst_A = np.zeros((m,Xtest.shape[0]))
    for i in range(m):
        Feat_tst_A[i,:] = np.exp(-(LA.norm(Xtest - D[i,:], 2, axis=1)**2)/s)
    
    Feat_trn_A = LA.lstsq( sciLA.sqrtm(Feat_C) , Feat_trn_A, rcond=None)[0]
    Feat_tst_A = LA.lstsq( sciLA.sqrtm(Feat_C) , Feat_tst_A, rcond=None)[0]
    
    return Feat_trn_A.T, Feat_tst_A.T


